//=============================================================================
// DX Cugpfr[ÃTv
//-----------------------------------------------------------------------------
//=============================================================================

#include <DxLib.h>
#include <LuminoMathDxLib.h>
#include "../Common.h"
using namespace Lumino;

int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	ChangeWindowMode(TRUE);

	if (DxLib_Init() == -1)	
		return -1;

	SetCameraNearFar(1.0f, 150.0f);

	int model = MV1LoadModel(LOCAL_RESOURCE("model.x"));

	Quaternion modelRot;	// f̉]p
	int lastMouseX = -1;	// }EXhbOʂ𒲂ׂ邽߂̕ϐ (ÕNbNʒu)
	int lastMouseY = -1;	// }EXhbOʂ𒲂ׂ邽߂̕ϐ (ÕNbNʒu)
	float cameraZ = -5.0f;	// J̑Oʒu

	// C[v
	while (ProcessMessage() == 0 && CheckHitKey(KEY_INPUT_ESCAPE) == 0)
	{
		//-----------------------------------------------------
		// }EXړʂ]pXV

		int mouseState = GetMouseInput();
		if (mouseState & MOUSE_INPUT_LEFT)
		{
			int mouseX, mouseY;
			GetMousePoint(&mouseX, &mouseY);

			if (lastMouseX >= 0)
			{
				// Õ}EXXWƂ̍pxƂāA݂̎pYŉ]
				modelRot.RotateY(0.01f * (lastMouseX - mouseX));
			}
			
			if (lastMouseY >= 0)
			{
				// Õ}EXYWƂ̍pxƂāA݂̎pXŉ]
				modelRot.RotateX(0.01f * (lastMouseY - mouseY));
			}
			
			lastMouseX = mouseX;
			lastMouseY = mouseY;
		}
		else
		{
			// }EXhbO
			lastMouseX = -1;
			lastMouseY = -1;
		}

		// Jʒu̓}EXzC[̈ړʂKɐݒ
		cameraZ += GetMouseWheelRotVol();


		//-----------------------------------------------------
		// `揈

		ClearDrawScreen();

		// Jʒu̐ݒ
		SetCameraPositionAndTargetAndUpVec(
			VGet(0, 0, cameraZ),
			VGet(0, 0, 0),
			VGet(0, 1, 0));

		// NH[^jI(]p)sɕϊăfɐݒA`悷
		Matrix modelMat = Matrix::RotationQuaternion(modelRot);
		MV1SetMatrix(model, modelMat);
		MV1DrawModel(model);

		// info
		DrawString(0, 0, "}EXhbOŃf]܂B", GetColor(255, 255, 255));
		DrawString(0, 16, "}EXzC[ŃJOɈړ܂B", GetColor(255, 255, 255));

		ScreenFlip();
	}

	DxLib_End();
	return 0;
}